import { BaseQuery } from './BaseQuery';
import { BaseTimeDimension } from './BaseTimeDimension';
export declare class BigqueryQuery extends BaseQuery {
    castToString(sql: any): string;
    convertTz(field: any): string;
    timeStampCast(value: any): string;
    dateTimeCast(value: any): string;
    escapeColumnName(name: any): string;
    timeGroupedColumn(granularity: any, dimension: any): string;
    /**
     * Returns sql for source expression floored to timestamps aligned with
     * intervals relative to origin timestamp point.
     * BigQuery operates with whole intervals as is without measuring them in plain seconds.
     */
    dateBin(interval: string, source: string, origin: string): string;
    /**
     * The input interval with (possible) plural units, like "2 years", "3 months", "4 weeks", "5 days"...
     * will be converted to BigQuery dialect.
     * @see https://cloud.google.com/bigquery/docs/reference/standard-sql/data-types#interval_type
     * It returns a tuple of (formatted interval, timeUnit to use in datediff functions)
     */
    private formatInterval;
    intervalAndMinimalTimeUnit(interval: string): [string, string];
    newFilter(filter: any): any;
    dateSeriesSql(timeDimension: BaseTimeDimension): string;
    seriesSql(timeDimension: BaseTimeDimension): string;
    timestampFormat(): string;
    timestampPrecision(): number;
    overTimeSeriesSelect(cumulativeMeasures: any, dateSeriesSql: any, baseQuery: any, dateJoinConditionSql: any, baseQueryAlias: any): string;
    subtractInterval(date: any, interval: any): string;
    addInterval(date: any, interval: any): string;
    subtractTimestampInterval(timestamp: any, interval: any): string;
    intervalString(interval: string): string;
    addTimestampInterval(timestamp: any, interval: any): string;
    nowTimestampSql(): string;
    unixTimestampSql(): string;
    /**
     * Should be protected, but BaseQuery is in js
     * Overridden from BaseQuery to support BigQuery strict data types for
     * joining conditions (note timeStampCast)
     */
    runningTotalDateJoinCondition(): (BaseTimeDimension | ((_dateFrom: string, dateTo: string, dateField: string, dimensionDateFrom: string, _dimensionDateTo: string) => string))[][];
    /**
     * Should be protected, but BaseQuery is in js
     * Overridden from BaseQuery to support BigQuery strict data types for
     * joining conditions (note timeStampCast)
     */
    rollingWindowToDateJoinCondition(granularity: any): (BaseTimeDimension | ((dateFrom: string, dateTo: string, dateField: string, _dimensionDateFrom: string, _dimensionDateTo: string, _isFromStartToEnd: boolean) => string))[][];
    /**
     * Should be protected, but BaseQuery is in js
     * Overridden from BaseQuery to support BigQuery strict data types for
     * joining conditions (note timeStampCast)
     */
    rollingWindowDateJoinCondition(trailingInterval: any, leadingInterval: any, offset: any): (BaseTimeDimension | ((dateFrom: string, dateTo: string, dateField: string, _dimensionDateFrom: string, _dimensionDateTo: string, isFromStartToEnd: boolean) => string))[][];
    dateFromStartToEndConditionSql(dateJoinCondition: any, fromRollup: any, isFromStartToEnd: any): any;
    preAggregationLoadSql(cube: any, preAggregation: any, tableName: any): any;
    hllInit(sql: any): string;
    hllMerge(sql: any): string;
    countDistinctApprox(sql: any): string;
    concatStringsSql(strings: any): string;
    defaultRefreshKeyRenewalThreshold(): number;
    defaultEveryRefreshKey(): {
        every: string;
    };
    sqlTemplates(): any;
}
//# sourceMappingURL=BigqueryQuery.d.ts.map